require "simplex"
require "config"
require "programs.landBiasNearRespawn"

local anywaterprop = 0.15
local deepwaterprop = 0.06

--returns: 0 for land, 1 for shallow water, 2 for deep water, 3 for shallow green water, 4 for deep green water
function runTileFastRivers(dx, dy)
	local rx = dx/600*Config.terrainScale
	local ry = dy/600*Config.terrainScale
	local noise = (SimplexNoise.Noise2DCompound(rx, ry, {1.25, 1.5, 2, 3, 4, 6, 7, 10, 15, 25, 35, 60}, {0.8, 0.95, 0.9, 0.75, 0.66, 0.55, 0.4, 0.25, 0.15, 0.1, 0.08, 0.06})) --range from -1 to +1
	local rangeadjustednoise = math.abs(noise) + landBiasNearRespawn(dx, dy, anywaterprop)
	if rangeadjustednoise < anywaterprop then
		return rangeadjustednoise < deepwaterprop and 2 or 1
	end
	return 0
end