require "config"

local spawns = {}

function isNearRespawn(x, y)
	if #spawns == 0 and game.tick < 60 then
		for i = 1,#game.players do
			spawns[#spawns+1] = game.players[i].position
		end
	end
	
	local maxd = 50 * Config.landBiasNearRespawnScale
	
	--find the distance from the NEAREST spawn point
	--we return a fractional value between 0 and 1, not just a logical
	--so we can't just stop at the first spawn point we find that's within range,
	--	because another spawn point might be closer,
	--		which would result in an even higher (fractional) return value (e.g. 0.8 instead of 0.3)
	local currentdist = maxd
	for i = 1,#spawns do
		local spawn = spawns[i]
		local dx = x-spawn.x
		local dy = y-spawn.y
		local dd = math.sqrt(dx*dx+dy*dy)
		if dd < currentdist then
			currentdist = dd
		end
	end

	if currentdist < maxd then
		return 1-currentdist/maxd
	else
		return 0
	end
end